// 003 u_html_downloader
// 31 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_html_downloader;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, ComCtrls, ScktComp
      ;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    exit_: TButton;
    clear_: TButton;
    PageControl2: TPageControl;
    display_: TTabSheet;
    Memo1: TMemo;
    download__: TTabSheet;
    download_memo_: TMemo;
    ClientSocket1: TClientSocket;
    Label1: TLabel;
    host_edit_: TEdit;
    Label2: TLabel;
    page_edit_: TEdit;
    connect_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure connect_Click(Sender: TObject);
    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
  private
  public
  end;

var
  Form1: TForm1;

implementation
  uses u_types_constants, u_characters, u_c_log, u_c_display
      , u_file, u_dir
      , u_strings
      , u_c_byte_buffer
      ;

    {$R *.DFM}

 
    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
      end; // FormCreate

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    // -- the on-form tClientSocket

    procedure TForm1.connect_Click(Sender: TObject);
      begin
        with ClientSocket1 do
        begin
          Close;
          Host:= host_edit_.Text;
          Port:= 80;
          Open();
        end;
      end; // with ClientSocket1

    const k_tcp_ip_chunk= 1024;
    var g_c_reception_buffer: c_byte_buffer= Nil;

    procedure TForm1.ClientSocket1Connect(Sender: TObject;
        Socket: TCustomWinSocket);
      var l_page: String;
          l_get_request: String;
      begin
        display('> connected');
        Caption:= 'http://'+ host_edit_.Text+ page_edit_.Text;

        // -- now send the HTTP get

        l_page:= page_edit_.Text;

        l_get_request:= 'GET '+ l_page+ ' HTTP/1.0'+ k_new_line
            + 'Accept: image/gif, image/x-xbitmap, image/jpeg, image/pjpeg, */*'+ k_new_line
            // + 'Accept-Encoding: gzip, deflate'+ k_new_line
            + 'User-Agent: Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1)'+ k_new_line
            + 'Host: '+ host_edit_.Text+ k_new_line
            // + 'Connection: Keep-Alive'+ k_new_line
            + k_new_line;
        display('===========>>');
        display(l_get_request);
        display('===========<<');

        g_c_reception_buffer.Free;
        g_c_reception_buffer:= c_byte_buffer.create_byte_buffer('reception', 2* 1024);

        ClientSocket1.Socket.SendBuf(Pointer(l_get_request)^, Length(l_get_request));
        display('< connected');
      end; // ClientSocket1Connect

    procedure TForm1.ClientSocket1Read(Sender: TObject;
          Socket: TCustomWinSocket);
      var l_bytes_received: Integer;
          l_remaining: Integer;
          l_pt_start_reception: Pointer;
      begin
        display('= receive ');

        with g_c_reception_buffer do
        begin
          // -- add the received data to the current buffer
          repeat
            l_remaining:= m_buffer_size- m_write_index;

            // -- if not at least a tcp-ip chunk, increase the room
            if l_remaining< k_tcp_ip_chunk
              then begin
                  display('  double '+ IntToStr(l_remaining));
                  // -- reallocate
                  double_the_capacity;
                  l_remaining:= m_buffer_size- m_write_index;
                end;

            l_pt_start_reception:= @ m_oa_byte_buffer[m_write_index];
            // -- get at most k_tcp_ip_chunk
            l_bytes_received:= ClientSocket1.Socket.ReceiveBuf(l_pt_start_reception^, k_tcp_ip_chunk);
            if l_bytes_received<= 0
              then begin
                  display('  ...no_more_for_now');
                  Break;
                end;

            if l_bytes_received> 0
              then begin
                  Inc(m_write_index, l_bytes_received);
                end; // if l_packet_bytes

            display(Format('    received %7d wr_ix %7d bf_sz %7d',
                [l_bytes_received, m_write_index, m_buffer_size]));
          until False;
        end; // with g_c_reception_buffer
      end; // ClientSocket1Read

    procedure TForm1.ClientSocket1Disconnect(Sender: TObject;
          Socket: TCustomWinSocket);
      begin
        display('disconnect ');
        with g_c_reception_buffer do
        begin
          display('received '+ IntToStr(m_write_index));
          save_to_file_start_end(f_exe_path+ '..\_data\resu.html',
              f_next_2_new_line_position(0)+ 4, m_write_index- 1);
          download_memo_.Lines.LoadFromFile('resu.txt');
        end;
      end; // ClientSocket1Disconnect


end.



